package javaposse.jobdsl.dsl.views

import javaposse.jobdsl.dsl.DslContext
import javaposse.jobdsl.dsl.JobManagement
import javaposse.jobdsl.dsl.View

import static javaposse.jobdsl.dsl.ContextHelper.executeInContext

class SectionedView extends View {
    SectionedView(JobManagement jobManagement) {
        super(jobManagement)
    }

    void sections(@DslContext(SectionsContext) Closure sectionsClosure) {
        SectionsContext context = new SectionsContext()
        executeInContext(sectionsClosure, context)

        execute {
            for (Node sectionNode : context.sectionNodes) {
                it / 'sections' << sectionNode
            }
        }
    }
}
